/*

DO NOT COPY or distribute this software with out PERMISSION from TDS200

Contact info: " tds200products@gmail.com ".

MCPE:MECH 3D car Mod

Created By TDS200

v0.1.0
*/
 
 
 /*
 Bug fixes
 
 
 */
 
 var car;
var isOncar = false;
var playerDir = [0, 0, 0];
var DEG_TO_RAD = Math.PI / 180;
var carSpeed = 0.4;
var rotFix;
var caronmap = false;


var timer = 0;
var gasAmount = 1;

Renderer = Renderer.createHumanoidRenderer();
addMobToRenderer(Renderer);



function addMobToRenderer(renderer){
model = renderer.getModel();

model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();

bipedBody = model.getPart("body");
bipedBody.setTextureOffset(0,0);

             //   l/r  u/d  F/B   w    h    l
 
bipedBody.addBox(-10 , -1 , -26 , 20 , 15 , 40 );

bipedBody.addBox(-8 , -15 , -10 , 2 , 15 , 2 );
bipedBody.addBox( 6 , -15 , -10 , 2 , 15 , 2 );
bipedBody.addBox(-10 , -17 , -10 , 20 , 2 , 25 );
bipedBody.addBox(-10 , -15 ,  12 , 20 , 15 , 2 );


bipedBody.setTextureSize(1,1);

bipedBody.addBox(-14 , 10 , -25 , 4 , 10 , 10 );
bipedBody.addBox( 10 , 10 , -25 , 4 , 10 , 10 );
bipedBody.addBox(-14 , 10 ,  3 , 4 , 10 , 10 );
bipedBody.addBox( 10 , 10 ,  3 , 4 , 10 , 10 );
bipedBody.addBox(-8 , 4 , -27 , 4 , 4 , 2 );
bipedBody.addBox( 4 , 4 , -27 , 4 , 4 , 2 );
}





/*
function procCmd(){
Player.addItemInventory(483,1,0);
Player.addItemInventory(471,1,0);
Player.addItemInventory(475,1,0);
}
*/




function attackHook(attacker , victim){

if(attacker == car){
preventDefault();
}

if(victim == car && getCarriedItem() == 471 ){
preventDefault();
Entity.rideAnimal(getPlayerEnt(),car);
isOncar = true;
}

if(victim == car && getCarriedItem() == 475 ){
preventDefault();
gasAmount = 5000
clientMessage(ChatColor.BLUE + "Fuel level:[||||||||||]");
}


if(victim == car && getCarriedItem() != 471 && getCarriedItem() != 475){
Level.dropItem(Entity.getX(car) , Entity.getY(car) , Entity.getZ(car) , 0 , 483 , 1 , 0);
Entity.remove(car);
caronmap = false;
ModPE.saveData("caronmap","false");
}

}




function useItem(x,y,z,i,b) {
var block = getTile(x,y+1,z);

if(i == 483 && caronmap == true){
clientMessage("You cannot place more than one car per map!");
}

if(i == 483 && caronmap == false) {

car = Level.spawnMob(x,y+1,z,11);

Entity.setMobSkin(car, "mob/car.png");

Entity.setRenderType(car , Renderer.renderType);

Entity.setHealth(car , 10000);

//Entity.rideAnimal(getPlayerEnt(),car);
//isOncar = true;

caronmap = true;
ModPE.saveData("caronmap","true");
Player.addItemInventory(483,-1,0);
}

}

function modTick() {

timer++;

if(ModPE.readData("caronmap") == "true" && timer > 50 && timer < 51){
Level.dropItem(getPlayerX() , getPlayerY() , getPlayerZ() , 0 , 483 , 1 , 0);
ModPE.saveData("caronmap","false");
}




if(getYaw() > 360 || getYaw() < -360){
setRot(getPlayerEnt(),0,getPitch());
}


if(gasAmount == 3750){
clientMessage(ChatColor.BLUE+"Fuel Level: [||||||||   ]");
}


if(gasAmount == 2500){
clientMessage(ChatColor.BLUE+"Fuel Level: [|||||     ]");
}


if(gasAmount == 1250){
clientMessage(ChatColor.RED+"Fuel Level: [|||       ]");
}


if(gasAmount == 0){
clientMessage(ChatColor.RED+"Out Of Fuel.");
}

if(gasAmount < 0 ){
isOncar = false;
unmannedcar();
}



if(getPlayerX() <  Entity.getX(car) -1 || getPlayerX() >  Entity.getX(car) +1  || getPlayerZ() <  Entity.getZ(car) -1 || getPlayerZ() >  Entity.getZ(car) +1){
isOncar = false;
unmannedcar();
}


if(isOncar == true) {
carTick();
var carblock = getTile(Entity.getX(car),Entity.getY(car) + 1,Entity.getZ(car));


//clientMessage(getYaw());
//clientMessage(Entity.getYaw(car));



//is facing north?
if( getYaw() > -45 && getYaw() < 45 || getYaw() > 315 || getYaw() > -315){
var carblockfront = getTile(Entity.getX(car),Entity.getY(car),Entity.getZ(car) +1);
var carblockup = getTile(Entity.getX(car),Entity.getY(car) +1,Entity.getZ(car) +1);
}

//is facing west?
if( getYaw() > 45 && getYaw() < 135 || getYaw() > -315 && getYaw() < -225){
var carblockfront = getTile(Entity.getX(car) -1,Entity.getY(car),Entity.getZ(car));
var carblockup = getTile(Entity.getX(car) -1,Entity.getY(car) +1,Entity.getZ(car));
}

//is facing south?
if( getYaw() > 135 && getYaw() < 225 || getYaw() > -225 && getYaw() < -135 ){
var carblockfront = getTile(Entity.getX(car),Entity.getY(car),Entity.getZ(car) -1);
var carblockup = getTile(Entity.getX(car),Entity.getY(car) +1,Entity.getZ(car) -1);
}

//is facing east?
if( getYaw() > 225 && getYaw() < 315 || getYaw() > -135 && getYaw() < -45 ){
var carblockfront = getTile(Entity.getX(car) +1,Entity.getY(car),Entity.getZ(car));
var carblockup = getTile(Entity.getX(car) +1,Entity.getY(car) +1,Entity.getZ(car));
}


if(carblockup == 0 && carblockfront != 0 && carblockfront != 31) {
setVelY(car, 0.5);
}


gasAmount--;



if(getYaw() > Entity.getYaw(car) + 30 ){
rotFix = 30;
}

if(getYaw() < Entity.getYaw(car) - 15 && getYaw() > Entity.getYaw(car) + 15 ){
rotFix = 0;
}


if(getYaw() < Entity.getYaw(car) - 30 ){
rotFix = -30;
}


Level.playSoundEnt(car , "random.fuse" , 100 , 30 );

setRot(car , getYaw() + rotFix , 0 );



}

}

function carTick() {
toDirectionalVector(playerDir, (getYaw() + 90) * DEG_TO_RAD , getPitch() * DEG_TO_RAD * -1);
setVelX(car, carSpeed * playerDir[0]);
//setVelY(car, carSpeed * playerDir[1]);
setVelZ(car, carSpeed * playerDir[2]);

}

function toDirectionalVector(vector, yaw, pitch) {	
vector[0] = Math.cos(yaw) * Math.cos(pitch);

//vector[1] = Math.sin(pitch);

vector[2] = Math.sin(yaw) * Math.cos(pitch);
}
  
  
  
function unmannedcar(){
setVelX(car,0);
setVelY(car,-0.5);
setVelZ(car,0);
setRot(car , 0 , 0 );
}  
  




function leaveGame(){
if(caronmap == true){
ModPE.saveData("caronmap","true");
}
}